C************************************************************************
C   PROGRAM DRIVESHAFT_LCF PREPARE INPUT DATA FILES 
C           FOR LOW CYCLE FATIGUE ANALYSIS
C
C      DEVELOPED BY ANGELES CREST ENGINEERING INC
C
C   DATE:       OCTOBER 2012
C
C   SUBPROGRAMS:INPUT, OUTPUT, STRAN, TRMNAT
C
C   FILES:      1:DRIVESHAFTLCFDAT-OLD; 2:COMPLCFDAT-NEW;    
C
C************************************************************************
      PROGRAM DRIVESHAFT_LCF

      IMPLICIT NONE
      
      LOGICAL   FILETEST2, FILETEST8

      INTEGER   MAXDAT, MAXM, MAXNGEOM, 
     &          MAXNLDHIS, MAXREG, MAXSET, MAXSGEOM

      PARAMETER (MAXDAT = 100, MAXM = 20000, MAXNGEOM = 3, 
     &          MAXNLDHIS = 1,  MAXREG = 3, MAXSET = 5, MAXSGEOM = 11)
            
      INTEGER   I, NDIV, NGEOM, NLDHIS, NPTS(0:MAXSET), NTIME, NUM, 
     &          REG, SGEOM(MAXNGEOM)

      REAL      BLOCK, EM, FTU, FTY, MAXGEOM(MAXNGEOM),   
     &          MINGEOM(MAXNGEOM), 
     &          LAMGEOMA(MAXNGEOM), LAMGEOMB(MAXNGEOM),
     &          LAMLDA(MAXNLDHIS), LAMLDB(MAXNLDHIS), PGEOM(MAXNGEOM),
     &          RAMCOEF, RAMEXPO, RATIO, RAWSTR(MAXDAT, 0:MAXSET), 
     &          RAWNF(MAXDAT, 0:MAXSET), LDHIS(MAXNLDHIS, MAXM),
     &          WEXP
      
      CHARACTER*40 DESCGEOM(MAXNGEOM)

      CHARACTER*40  DESCRP(0:MAXSET)    

      REAL      PI
                
      PARAMETER (PI = 3.1415926536)

C ** OPEN INPUT AND OUTPUT FILES ==============================================
      OPEN (1,  FILE = 'DRIVESHAFTLCFDAT', STATUS = 'OLD')
      INQUIRE (FILE = 'COMPLCFDAT', EXIST = FILETEST2)
      INQUIRE (FILE = 'DSOUT', EXIST = FILETEST8)

      IF (FILETEST2 .EQV. .TRUE.) THEN
        OPEN (2,  FILE = 'COMPLCFDAT', STATUS = 'OLD')
        CLOSE (UNIT=2, STATUS='DELETE')
      ENDIF  

      IF (FILETEST8 .EQV. .TRUE.) THEN
        OPEN (8,  FILE = 'DSOUT', STATUS = 'OLD')
        CLOSE (UNIT=8, STATUS='DELETE')
      ENDIF  

      OPEN (2,  FILE = 'COMPLCFDAT', STATUS = 'NEW')
      OPEN (8,  FILE = 'DSOUT', STATUS = 'NEW')

C READ DATA FROM DRIVESHAFTLCFDAT
      CALL INPUT (BLOCK, NDIV, NGEOM, NLDHIS, NPTS, NTIME, NUM, 
     &          REG, SGEOM, EM, FTU, FTY, MAXGEOM, MINGEOM,  
     &          LAMGEOMA, LAMGEOMB, LAMLDA, LAMLDB, PGEOM,
     &          RAMCOEF, RAMEXPO, RATIO, RAWSTR, RAWNF, LDHIS,
     &          WEXP, DESCGEOM, DESCRP)
      
C   WRITE DATA TO COMPLCFDAT     
      CALL OUTPUT (BLOCK, NDIV, NGEOM, NLDHIS, NPTS, NTIME, NUM, 
     &          REG, SGEOM, EM, FTU, FTY, MAXGEOM, MINGEOM,  
     &          LAMGEOMA, LAMGEOMB, LAMLDA, LAMLDB, PGEOM,
     &          RAMCOEF, RAMEXPO, RATIO, RAWSTR, RAWNF, 
     &          WEXP, DESCGEOM, DESCRP)
            
      CALL STRAN(LDHIS, NLDHIS, NTIME, PGEOM) 
      
      STOP 
      
      END

C************************************************************************
C   SUBROUTINE INPUT READS IN THE DATA FROM DRIVESHAFTLCFDAT
C
C   DATE :      OCTOBER 2012
C
C************************************************************************
      SUBROUTINE INPUT (BLOCK, NDIV, NGEOM, NLDHIS, NPTS, NTIME, NUM, 
     &          REG, SGEOM, EM, FTU, FTY, MAXGEOM, MINGEOM,
     &          LAMGEOMA, LAMGEOMB, LAMLDA, LAMLDB, PGEOM,
     &          RAMCOEF, RAMEXPO, RATIO, RAWSTR, RAWNF, LDHIS,
     &          WEXP, DESCGEOM, DESCRP)
 
      INTEGER   MAXDAT, MAXM, MAXNGEOM, MAXNLDHIS, MAXREG, MAXSGEOM, 
     &          MAXSET

      PARAMETER (MAXDAT = 100, MAXM = 20000, MAXNGEOM = 3, 
     &          MAXNLDHIS = 1, MAXREG = 3, MAXSET = 5, MAXSGEOM = 11)

      INTEGER   COUNT, FILNUM(4), I, IOUT, J, M, NDIV, 
     &          NGEOM, NLDHIS, NPTS(0:MAXSET), NTIME, NUM, 
     &          REG, SGEOM(MAXNGEOM)

      REAL      BLOCK, EM, FTU, FTY, HISLIFE, MAXGEOM(MAXNGEOM), 
     &          MINGEOM(MAXNGEOM),  
     &          MISSIONLIFE, LAMGEOMA(MAXNGEOM), LAMGEOMB(MAXNGEOM),
     &          LAMLDA(MAXNLDHIS), LAMLDB(MAXNLDHIS), PGEOM(MAXNGEOM),
     &          RAMCOEF, RAMEXPO, RATIO, RAWSTR(MAXDAT, 0:MAXSET), 
     &          RAWNF(MAXDAT, 0:MAXSET), LDHIS(MAXNLDHIS, MAXM),
     &          WEXP
     
      CHARACTER*6   LDNAME(6)
      
      CHARACTER*40  DESCGEOM(MAXNGEOM)

      CHARACTER*40  DESCRP(0:MAXSET)
       
      COMMON    IOUT
      
      LOGICAL   FTEST
   
      DATA (LDNAME(I), I = 1, 4) /
     &     'LDHIS1','LDHIS2','LDHIS3','LDHIS4'/
     
      DATA (FILNUM(I), I = 1, 4) /
     &     11, 12, 13, 14 /

      READ(1,*) NLDHIS,  NTIME, HISLIFE, MISSIONLIFE
      
      IF (NLDHIS .GT. MAXNLDHIS)THEN
        WRITE(8,*) 'ERROR: TOO MANY LOAD HISTORYS'
        CALL TRMNAT
      ENDIF
      
      IF (NTIME .GT. MAXM) THEN
        WRITE(8,*) 'ERROR:  LOAD TIME HISTORY TOO LARGE'
        CALL TRMNAT
      ENDIF
            
      IF (HISLIFE .GT. MISSIONLIFE) THEN
        WRITE(8,*) 'ERROR: HISTORY DURATION LONGER THAN MISSION LIFE'
        CALL TRMNAT
      ENDIF

C   CALCULATE BLOCK (MISSION LIFE / HISTORY DURATION)      
      BLOCK = MISSIONLIFE/HISLIFE
   
      DO 15 I = 1, NLDHIS
        READ(1,*)   LAMLDA(I), LAMLDB(I)
   15 CONTINUE

C ** READ COMPONENT DATA 
      READ(1,*) NGEOM
      
      IF (NGEOM .GT. MAXNGEOM)THEN
        WRITE(8,*) 'ERROR: TOO MANY PARAMETERS'
        CALL TRMNAT
      ENDIF
      
C   INITIALIZE SGEOM, PGEOM
      DO 11 I = 1, MAXNGEOM
        SGEOM(I) = 1
        PGEOM(I) = 0
   11 CONTINUE
            
      DO 10 I = 1, NGEOM
        READ(1,*)   DESCGEOM(I), PGEOM(I), MINGEOM(I), MAXGEOM(I), 
     &              LAMGEOMA(I), LAMGEOMB(I), SGEOM(I)
        IF ((SGEOM(I) .EQ. 1) .AND. 
     &           (MAXGEOM(I) .NE. MINGEOM(I))) THEN
            WRITE(8,*) 'ERROR: SGEOM =1 WHEN MAXGEOM = MINGEOM'
            CALL TRMNAT
        ENDIF
        IF (SGEOM(I) .GT. MAXSGEOM) THEN
            WRITE(8,*) 'ERROR: TOO MANY SEGMENTS FOR PARAMETER ', NGEOM
            CALL TRMNAT
        ELSE IF (SGEOM(I) .LE. 0) THEN
            WRITE(8,*) 'ERROR: NEGATIVE SEGMENT FOR PARAMETER ', NGEOM
            CALL TRMNAT
        ENDIF
   10 CONTINUE   
          
      READ(1,*) EM, RAMCOEF, RAMEXPO, WEXP

C  READ LOAD TIME HISTORY FROM FILES
      DO 40 I = 1, NLDHIS
         INQUIRE (FILE = LDNAME(I), EXIST = FTEST)
         IF (FTEST .EQV. .TRUE.) THEN
            OPEN (FILNUM(I), FILE = LDNAME(I), STATUS = 'OLD')
            DO 35 J = 1, NTIME
               READ(FILNUM(I),*) LDHIS(I, J)
   35       CONTINUE
            CLOSE (FILNUM(I))
         ELSE
            WRITE(8,*) 'ERROR: CANNOT OPEN FILE, ', LDNAME(I), 
     &                ' DOES NOT EXIST'
            CALL TRMNAT
         ENDIF
   40 CONTINUE
      
C   INPUT DATA ON SPECIFIC MATERIAL
      READ(1,*) DESCRP(0), FTY, FTU, NDIV, NPTS(0)

      IF (NPTS(0) .GT. MAXDAT) THEN
         WRITE(8,*) 'ERROR:  OVER NUMBER OF POINTS LIMIT IN ',
     &              'SPECIFIC MATERIAL'
         CALL TRMNAT
      ENDIF

C   INITIALIZE COUNT
      COUNT = 0

C   INPUT STRESS/LIFE INFORMATION -- INCLUDING STRESS RATIO AND REGION 
C       INFORMATION 
      DO 100 M = 1, NDIV

         READ (1,*) NUM, RATIO, REG

         IF (ABS(RATIO) .GT. 1.0) THEN
            WRITE(8,*) 'ERROR:  INVALID VALUE FOR RATIO:  ', RATIO
            CALL TRMNAT
         ENDIF

         IF (REG .GT. MAXREG) THEN
            WRITE(8,*) 'ERROR:  OVER REGION LIMIT IN SPECIFIC DATA SET'
            CALL TRMNAT
         ENDIF

         DO 200 I = (COUNT + 1), (COUNT + NUM)
            READ (1,*) RAWSTR(I, 0), RAWNF(I, 0)
  200    CONTINUE
  
           COUNT = COUNT + NUM

  100 CONTINUE  
     
      RETURN
      END

C************************************************************************
C   SUBROUTINE OUTPUT CREATE THE DATAFILE COMPLCFDAT FOR LCF INPUT
C
C   DATE :      OCTOBER 2012
C
C************************************************************************
      SUBROUTINE OUTPUT (BLOCK, NDIV, NGEOM, NLDHIS, NPTS, NTIME, NUM, 
     &          REG, SGEOM, EM, FTU, FTY, MAXGEOM, MINGEOM,  
     &          LAMGEOMA, LAMGEOMB, LAMLDA, LAMLDB, PGEOM,
     &          RAMCOEF, RAMEXPO, RATIO, RAWSTR, RAWNF, 
     &          WEXP, DESCGEOM, DESCRP)
 
      INTEGER   MAXDAT, MAXM, MAXNGEOM, MAXNLDHIS, MAXREG, MAXSGEOM, 
     &          MAXSET

      PARAMETER (MAXDAT = 100, MAXM = 20000, MAXNGEOM = 3, 
     &          MAXNLDHIS = 1, MAXREG = 3, MAXSET = 5, MAXSGEOM = 11)

      INTEGER   COUNT, FILNUM(4), I, IOUT, J, M, NDIV, 
     &          NGEOM, NLDHIS, NPTS(0:MAXSET), NTIME, NUM, 
     &          REG, SGEOM(MAXNGEOM)

      REAL      BLOCK, EM, FTU, FTY, MAXGEOM(MAXNGEOM), 
     &          MINGEOM(MAXNGEOM),  
     &          LAMGEOMA(MAXNGEOM), LAMGEOMB(MAXNGEOM),
     &          LAMLDA(MAXNLDHIS), LAMLDB(MAXNLDHIS), PGEOM(MAXNGEOM),
     &          RAMCOEF, RAMEXPO, RATIO, RAWSTR(MAXDAT, 0:MAXSET), 
     &          RAWNF(MAXDAT, 0:MAXSET), LDHIS(MAXNLDHIS, MAXM),
     &          WEXP
     
      CHARACTER*6   LDNAME(6)
      
      CHARACTER*40  DESCGEOM(MAXNGEOM)

      CHARACTER*40  DESCRP(0:MAXSET)
       
      COMMON    IOUT
      
      WRITE(2,*) NLDHIS, NTIME, BLOCK
         
      DO 15 I = 1, NLDHIS
        WRITE(2,*)  LAMLDA(I), LAMLDB(I)
   15 CONTINUE

C ** WRITE COMPONENT DATA 
      WRITE(2,*) NGEOM
                  
      DO 10 I = 1, NGEOM
        WRITE(2,*)  '''',DESCGEOM(I), '''',PGEOM(I)
        WRITE(2,*)  MINGEOM(I), MAXGEOM(I), 
     &              LAMGEOMA(I), LAMGEOMB(I), SGEOM(I)
   10 CONTINUE   
          
      WRITE(2,*) EM
      WRITE(2,*) RAMCOEF
      WRITE(2,*) RAMEXPO
      WRITE(2,*) WEXP
   
C   OUPUT DATA ON SPECIFIC MATERIAL
      WRITE(2,*) '''',DESCRP(0),''''
      WRITE(2,*) FTY, FTU, NDIV, NPTS(0)

C   INITIALIZE COUNT
      COUNT = 0

C   OUTPUT STRESS/LIFE INFORMATION -- INCLUDING STRESS RATIO AND REGION 
C       INFORMATION
      DO 100 M = 1, NDIV

         WRITE (2,*) NUM, RATIO, REG

         DO 200 I = (COUNT + 1), (COUNT + NUM)
            WRITE (2,*) RAWSTR(I, 0), RAWNF(I, 0)
  200    CONTINUE
  
           COUNT = COUNT + NUM

  100 CONTINUE  
     
      RETURN
      END
      
C************************************************************************ 
C   SUBROUTINE STRAN PERFORMS THE LOAD TO UNIT PARAMETER STRESS 
C       TRANSFORMATION AND CREATE THE UNIT PARAMETER STRESS DAT FILE
C
C   DATE:       OCTOBER 2012
C************************************************************************ 
      SUBROUTINE STRAN (LDHIS, NLDHIS, NTIME)
 
      INTEGER   FILNUM(4), MAXM, MAXNGEOM, MAXNLDHIS
 
      REAL      PINERTIA
      
      PARAMETER (PINERTIA = 1, MAXM = 20000, MAXNGEOM = 3, 
     &          MAXNLDHIS = 1) 
 
      COMMON    IOUT 
 
      INTEGER   I, IOUT, J, K, NGEOM, NLDHIS, NTIME 
 
      REAL      LDHIS(MAXNLDHIS,MAXM), PGEOM(MAXNGEOM), 
     &          USTRHIS(MAXNLDHIS,MAXM)
      
      CHARACTER*8 LDNAME(4)

      LOGICAL   FTEST
 
      DATA (LDNAME(I), I = 1, 4) /
     &     'STRHIS1','STRHIS2','STRHIS3','STRHIS4'/
     
      DATA (FILNUM(I), I = 1, 4) /
     &     21, 22, 23, 24 /
     
C   DERIVE VON MISES STRESS HISTORY FROM LOAD HISTORY FOR DRIVESHAFT 
C      (STRESS = TORQUE * (OUTER DIAMETER /POLAR MOMENT OF INERTIA))
C   PINERTIA = POLAR MOMENT OF INERTIA/OUTER DIAMETER
C   * 12.0 to convert from ft-lb to in-lb
C   / 1000 to convert from psi to ksi. 
      DO 100 I = 1, NTIME
        USTRHIS(1,I) = SQRT(3.0) * LDHIS(1,I) * 12.0  /  PINERTIA 
     &              / 1000.0   
  200   CONTINUE      
  100 CONTINUE   

C  WRITE UNIT PARAMETER STRESS TIME HISTORY TO FILES
      DO 40 I = 1, NLDHIS
         INQUIRE (FILE = LDNAME(I), EXIST = FTEST)
         IF (FTEST .EQV. .TRUE.) THEN
            OPEN (FILNUM(I),  FILE = LDNAME(I), STATUS = 'OLD')
            CLOSE (UNIT=FILNUM(I), STATUS='DELETE')
         ENDIF
         
         OPEN (FILNUM(I), FILE = LDNAME(I), STATUS = 'NEW')
            DO 35 J = 1, NTIME
               WRITE (FILNUM(I),*) USTRHIS(I, J)
   35       CONTINUE
         CLOSE (FILNUM(I))
   40 CONTINUE
          
      RETURN  
      
      END 
      
C************************************************************************
C   SUBROUTINE TRMNAT HANDLES THE TERMINATION OF THE PROGRAM RUN WHEN
C       ONE OF THE PROGRAM'S ASSUMPTIONS HAVE BEEN VIOLATED
C
C************************************************************************
      SUBROUTINE TRMNAT

      WRITE(8,*) 'PROGRAM EXECUTION TERMINATED'
      STOP
      END  
