C************************************************************************
C   PROGRAM WEAR CONTROLS THE FLOW OF LOGIC OF A CLUTCH WEAR ANALYSIS
C   
C   DEVELOPED BY ANGELES CREST ENGINEERING INC
C
C   DATE:       NOVEMBER 2012
C     
C   SUBPROGRAMS:INFAGW, INPUT, PARDRW, WORSTNW, 
C                   TRMNAT, WEARCAL, INSORT, STRAN
C
C   FILES:      1:WEARDAT-OLD;  2: COMPWEARDAT-OLD;  3:WEAROUT-NEW; 
C               8:IOUTPR-NEW;   9:LOWLIF-NEW;
C***********************************************************************
      PROGRAM WEAR

      IMPLICIT NONE

      LOGICAL   FILETEST3, FILETEST8, FILETEST9

      INTEGER   MAXBLF, MAXLIF, MAXNGEOM, MAXSGEOM

      PARAMETER (MAXBLF = 35, MAXLIF = 100000,
     &           MAXNGEOM = 4, MAXSGEOM = 11)

      COMMON    IOUT

      INTEGER   BLFPOS(MAXBLF), I, IOUT, J, K, L, M, N, P, Q,
     &          NBLIFE, NGEOM, NHYPER, NLIFE, NLIFET,  
     &          SGEOM(MAXNGEOM), FITFILNUM(9)

      DOUBLE PRECISION  RAND

      REAL     BLFPER(MAXBLF), EPSL, 
     &         GEOM(MAXNGEOM), GEOMDATA(MAXNGEOM, MAXSGEOM), 
     &         INVLIFEL(MAXLIF), 
c     &         INVLIFLA(MAXSGEOM, MAXSGEOM, MAXSGEOM, MAXSGEOM, MAXLIF), 
     &         LAMGEOM(MAXNGEOM),  
c     &         LIFEL_A(MAXSGEOM, MAXSGEOM, MAXSGEOM, MAXSGEOM, MAXLIF), 
     &         LIFEL(MAXLIF), LIFL, TOTLIF
     
      REAL     WEARFRACTION(MAXLIF), WEARRATE, WEARMEAN, WEARSIGMA, 
     &         WEARLAMDA, 
     &         WEARFRACTION_A(MAXSGEOM,MAXSGEOM,MAXSGEOM, MAXLIF)
c     &         WEARFRACTIONA(MAXSGEOM, MAXSGEOM, MAXSGEOM, MAXSGEOM, 
c     &         MAXLIF)
     
      CHARACTER*40 DESCGEOM(MAXNGEOM)

      LOGICAL   FTEST

      CHARACTER*10 FITDATANAME(4)
      
      DATA (FITDATANAME(I), I = 1, 4) /
     &     'FITDATA1','FITDATA2','FITDATA3','FITDATA4'/
     
      DATA (FITFILNUM(I), I = 1, 4) /
     &     21, 22, 23, 24/


     
C ** OPEN INPUT AND OUTPUT FILES ==============================================

      OPEN (1,  FILE = 'WEARDAT', STATUS = 'OLD')
      OPEN (2,  FILE = 'COMPWEARDAT', STATUS = 'OLD')
      INQUIRE (FILE = 'WEAROUT', EXIST = FILETEST3)
      INQUIRE (FILE = 'IOUTPR', EXIST = FILETEST8)
      INQUIRE (FILE = 'LOWLIF', EXIST = FILETEST9)
      IF (FILETEST3 .EQV. .TRUE.) THEN
        OPEN (3,  FILE = 'WEAROUT', STATUS = 'OLD')
        CLOSE (UNIT=3, STATUS='DELETE')
      ENDIF  
      IF (FILETEST8 .EQV. .TRUE.) THEN
        OPEN (8,  FILE = 'IOUTPR', STATUS = 'OLD')
        CLOSE (UNIT=8, STATUS='DELETE')
      ENDIF  
      IF (FILETEST9 .EQV. .TRUE.) THEN  
        OPEN (9,  FILE = 'LOWLIF', STATUS = 'OLD')
        CLOSE (UNIT=9, STATUS='DELETE')
      ENDIF  
      
      OPEN (3,  FILE = 'WEAROUT', STATUS = 'NEW')
      OPEN (8,  FILE = 'IOUTPR', STATUS = 'NEW')
      OPEN (9,  FILE = 'LOWLIF', STATUS = 'NEW')
       
C===============================================================================
      CALL INPUT (BLFPER, GEOMDATA, NGEOM, 
     &              NBLIFE, NHYPER, NLIFE, RAND, SGEOM, 
     &              DESCGEOM, WEARRATE, WEARMEAN, WEARSIGMA)
             
C    INITIALIZE VARIABLE
      DO 10 I = 1, MAXNGEOM
        GEOM(I) = 0.0
   10 CONTINUE 
   
      NLIFET = NHYPER * NLIFE

C   PARAMETER 1 LOOP    
      DO 500 M = 1, SGEOM(1)
            
C   PARAMETER 2 LOOP
        DO 510 N = 1, SGEOM(2)   

C   PARAMETER 3 LOOP
            DO 520 P = 1, SGEOM(3)     

C   PARAMETER 4 LOOP
                DO 530 Q = 1, SGEOM(4)                  
                    GEOM(1) =  GEOMDATA(1,M)
                    WRITE (8,*) 'PARAMETER #1 = ', DESCGEOM(1), '=', 
     &                      GEOM(1)
                    WRITE (9,*) 'PARAMETER #1 = ', DESCGEOM(1), '=', 
     &                      GEOM(1)
     
                    IF (NGEOM .GT. 1)   THEN
                        GEOM(2) = GEOMDATA(2,N)
                        WRITE (8,*) 'PARAMETER #2 = ', DESCGEOM(2), '=', 
     &                          GEOM(2)
                        WRITE (9,*) 'PARAMETER #2 = ', DESCGEOM(2), '=', 
     &                          GEOM(2)
                        IF (NGEOM .GT. 2)   THEN
                            GEOM(3) = GEOMDATA(3,P)
                            WRITE (8,*) 'PARAMETER #3 = ', DESCGEOM(3), 
     &                          '=', GEOM(3)
                            WRITE (9,*) 'PARAMETER #3 = ', DESCGEOM(3),  
     &                          '=', GEOM(3)
                            IF (NGEOM .GT. 3)   THEN
                                GEOM(4) = GEOMDATA(4,Q)
                                WRITE (8,*) 'PARAMETER #4 = ',  
     &                              DESCGEOM(4), '=', GEOM(4)
                                WRITE (9,*) 'PARAMETER #4 = ', 
     &                              DESCGEOM(4), '=', GEOM(4)
                            ENDIF
                        ENDIF        
                    ENDIF
      
                    DO 35 K = 1, MAXLIF
                        LIFEL(K) = 1.0E+36
   35               CONTINUE

C   OUTER LOOP -- THIS LOOP SAMPLES HYPER-PARAMETER SETS
                    DO 150 K = 1, NHYPER

C   INNER LOOP -- THIS LOOP GENERATES FAILURE TIMES
                        DO 200 I = 1, NLIFE

C   PERFORM DRIVER DRAWS
                            CALL PARDRW (LAMGEOM, RAND)
                        
                            CALL NORMGN (RAND, WEARMEAN, WEARSIGMA, 
     &                          WEARLAMDA)
      
                            EPSL = 1.00
  
C   CALL WEARCAL TO OBTAIN WEAR LIFE
                            CALL WEARCAL (GEOM, LAMGEOM, TOTLIF,
     &                          WEARRATE, WEARLAMDA)

                            LIFL = EPSL * TOTLIF

                            IF (NLIFET .GE. 100) THEN
                                CALL INSORT (LIFL, LIFEL, NLIFET)
                            ENDIF
       
  200                   CONTINUE

  150               CONTINUE


C   CALCULATE DAMAGE
                    DO 160 J = 1, NLIFET
                        WEARFRACTION(J) = 1.0 / LIFEL(J)
                        WEARFRACTION_A(M, N, P, J) = WEARFRACTION(J)
                        IF ( WEARFRACTION(J) .LE. 0.6 )  THEN
                            INVLIFEL(J) = 0.0
                        ELSE IF (WEARFRACTION(J) .GE. 0.9) THEN
                            INVLIFEL(J) = 1.0
                        ELSE
                            INVLIFEL(J) = ( WEARFRACTION(J) - 0.6 ) 
     &                       / 0.3
                        ENDIF
  160               CONTINUE

C   INITIALIZE VARIABLE BLFPOS()
                    DO 325 J = 1, MAXBLF
                        BLFPOS(J) = 0
  325               CONTINUE

C   PRINT EMPIRICAL BLIVES
                    WRITE(3,*) ''
                    WRITE(3,*) ''
                    WRITE(3,*) 'WEARFRACTION AND DAMATGE DATA FOR'
                    
                    WRITE(3,*) 'PARAMETER #1 ', DESCGEOM(1), '=', 
     &                          GEOM(1)
                    IF (NGEOM .GT. 1)   THEN
                        WRITE(3,*) 'PARAMETER #2 ', DESCGEOM(2), '=', 
     &                          GEOM(2)
                        IF (NGEOM .GT. 2)  THEN
                            WRITE(3,*) 'PARAMETER #3 ', DESCGEOM(3),  
     &                          '=', GEOM(3)
                            IF (NGEOM .GT. 3)  THEN
                                WRITE(3,*) 'PARAMETER #4 ', DESCGEOM(4),  
     &                              '=', GEOM(4)
                            ENDIF
                        ENDIF                                       
                    ENDIF

                    WRITE(3,925)

                     DO 350 J = 1, NBLIFE
                        BLFPOS(J) = NINT (BLFPER(J) * FLOAT (NLIFET))
                        WRITE(3,926) BLFPER(J), WEARFRACTION(BLFPOS(J)), 
     &                      INVLIFEL(BLFPOS(J))
  350               CONTINUE
         
c                DO 540 J = 1, NLIFET
c                    LIFEL_A(M, N, P, Q, J) = LIFEL(J)
c                    INVLIFLA(M, N, P, Q, J) = INVLIFEL(J)
c                    WEARFRACTIONA(M, N, P, Q, J) = WEARFRACTION(J)                    
c  540           CONTINUE 

C   GEOMETRIC PARAMETER 4 LOOP END       
  530           CONTINUE 
  
C   GEOMETRIC PARAMETER 3 LOOP END       
  520       CONTINUE                
C   GEOMETRIC PARAMETER 2 LOOP END   
  510   CONTINUE        
C   GEOMETRIC PARAMETER 1 LOOP END  
  500 CONTINUE    
  
C   WRITE DAMAGE FOR DATA FIT
c      DO 370 I = 1, 2
c         INQUIRE (FILE = FITDATANAME(I), EXIST = FTEST)
c         IF (FTEST .EQV. .TRUE.) THEN
c            OPEN (FITFILNUM(I), FILE = FITDATANAME(I), STATUS = 'OLD')
c            CLOSE(FITFILNUM(I), STATUS='DELETE')
c         ELSE
c            OPEN (FITFILNUM(I),  FILE = FITDATANAME(I), STATUS = 'NEW')
c            DO 360 J = 1, NLIFET
c                WRITE(FITFILNUM(I),*) WEARFRACTION_A(1, I, 1, J), 
c     &           WEARFRACTION_A(2, I, 1, J), WEARFRACTION_A(3, I, 1, J), 
c     &           WEARFRACTION_A(4, I, 1, J), WEARFRACTION_A(5, I, 1, J), 
c     &           WEARFRACTION_A(6, I, 1, J), WEARFRACTION_A(7, I, 1, J), 
c     &           WEARFRACTION_A(8, I, 1, J), WEARFRACTION_A(9, I, 1, J)
c  360       CONTINUE
c         ENDIF
c  370 CONTINUE
  
c      DO 380 I = 1, 2
c         INQUIRE (FILE = FITDATANAME(I+2), EXIST = FTEST)
c         IF (FTEST .EQV. .TRUE.) THEN
c            OPEN (FITFILNUM(I+2), FILE = FITDATANAME(I+2),STATUS ='OLD')
c            CLOSE(FITFILNUM(I+2), STATUS='DELETE')
c         ELSE
c            OPEN (FITFILNUM(I+2),  FILE = FITDATANAME(I+2),STATUS='NEW')
c            DO 390 J = 1, NLIFET
c                WRITE(FITFILNUM(I+2),*) WEARFRACTION_A(1, I, 2, J), 
c     &           WEARFRACTION_A(2, I, 2, J), WEARFRACTION_A(3, I, 2, J), 
c     &           WEARFRACTION_A(4, I, 2, J), WEARFRACTION_A(5, I, 2, J), 
c     &           WEARFRACTION_A(6, I, 2, J), WEARFRACTION_A(7, I, 2, J), 
c     &           WEARFRACTION_A(8, I, 2, J), WEARFRACTION_A(9, I, 2, J)
c  390       CONTINUE
c         ENDIF
c  380 CONTINUE
 
      
  925 FORMAT(/,2X,'B LIVES:        WEARFRACTION          DAMAGE',/)

  926 FORMAT(2X,F7.5,5X,E13.6,5X,E13.6)
  927 FORMAT(2X,F10.7,2X,F10.7,2X, E13.7,2X,F10.7,2X,E13.7)
  
      STOP

      END

C************************************************************************
C   SUBROUTINE WEARCAL CALCULATES THE WEAR GIVEN THE STRESS HISTORY 
C
C   DATE:       NOVEMBER 2012
C
C   INPUTS:     DEE, MM, NUMREG, NTIME, STRHIS 
C                
C   OUTPUTS:    TOTLIF
C
C       LIST OF VARIABLES
C
C IOUT       CONTROLS DUMP TO FILE IOUTPR
C MAXM       MAXIMUM NUMBER OF POINTS ALLOWED IN TIME HISTORY
C MAXREG     MAXIMUM NUMBER OF REGIONS ALLOWED
C MM()       1-D ARRAY CONTAINING VALUES OF M FOR EACH REGION
C NTIME      NUMBER OF POINTS IN STRESS-TIME HISTORY
C NUMREG     NUMBER OF REGIONS OF INTEREST
C
C************************************************************************
      SUBROUTINE WEARCAL (GEOM, LAMGEOM, TOTLIF, WEARRATE, 
     &                   WEARLAMDA)

      INTEGER  MAXNGEOM

      PARAMETER (MAXNGEOM = 4)

      COMMON   IOUT

      INTEGER  I, IOUT, J

      REAL     A, DELTAH, DS, F, GEOM(MAXNGEOM),
     &         LAMGEOM(MAXNGEOM), TOTLIF, W
             
      REAL     WEARRATE, WEARLAMDA
      
            W = WEARRATE * WEARLAMDA
            DS = GEOM(1) * LAMGEOM(1)
            F = GEOM(2) * LAMGEOM(2)
            A = GEOM(3) * LAMGEOM(3)
            CRITWEAR = GEOM(4) * LAMGEOM(4)
                       
C  CALCULATE WEAR 
            DELTAH = 0.5 * W *  F * DS / A

C   CALCULATE LIFE
            TOTLIF = CRITWEAR / DELTAH
            
      RETURN
      END

C************************************************************************
C   SUBROUTINE INSORT PERFORMS AN INSERTION SORT FOR EACH LIFE CALCULATED
C
C   DATE:       OCTOBER 2012
C
C   VERSION:    2.1
C
C   SUBPROGRAMS:N/A
C
C   INPUTS:     NEWLIF, LIFE, NLIFET
C
C   OUTPUTS:    LIFE
C
C           LIST OF VARIABLES
C
C   I           CONTROLS DO LOOP FOR INSERTION
C   IOUT        OUTPUT DUMP CONTROLLER
C   LIFE()      1-D ARRAY CONTAINING TAIL VALUES OF THE LIVES GENERATED BY THE
C                   PFM TO BE SORTED
C   MAXLIF      MAXIMUM NUMBER OF FATIGUE LIVES ALLOWED FOR BETA, THETA, ALPHA,
C                   CALCULATION
C   NEWLIF      LIFE VALUE TO BE INSERTED INTO LIFE()
C   NLIFET      TOTAL NUMBER OF LIVES CALCULATED BY PFM
C   NUM         NUMBER OF LIFE VALUES IN LIFE()
C   PLACE       POSITION WHERE NEWLIF IS TO BE INSERTED INTO LIFE()
C   TEMP()      1-D ARRAY CONTAINING VALUES OF LIFE() TO BE SHIFTED UPON 
C                   INSERTION OF NEWLIF
C
C************************************************************************
      SUBROUTINE INSORT (NEWLIF, LIFE, NLIFET)

      INTEGER  MAXLIF

      PARAMETER (MAXLIF = 100000)

      COMMON   IOUT

      INTEGER  I, IOUT, NLIFET, NUM, PLACE

      REAL     LIFE(MAXLIF), NEWLIF, TEMP(MAXLIF)


c      NUM = NLIFET / 2
      NUM = NLIFET
        
C     FIND POSITION IN LIFE() FOR NEWLIF
c      IF (NEWLIF .GE. LIFE(NUM)) GOTO 400

      DO 100 I = 1, NUM
         IF (NEWLIF .LT. LIFE(I)) THEN
            PLACE = I
            GOTO 110
         ENDIF
  100 CONTINUE
  110 CONTINUE

C     STORE VALUES OF LIFE() TO BE SHIFTED DUE TO NEWLIF INSERTION IN TEMP()
      DO 200 I = (PLACE + 1), NUM
         TEMP(I) = LIFE(I-1)
  200 CONTINUE

C     INSERT NEWLIF
      LIFE(PLACE) = NEWLIF

C     SHIFT VALUES OF LIFE() FOLLOWING NEWLIF
      DO 300 I = (PLACE + 1), NUM
         LIFE(I) = TEMP(I)
  300 CONTINUE

C     IF NEWLIF IS LARGER THAN ALL LIVES IN LIFE() THEN RETURN
c  400 CONTINUE

      RETURN
      END
      
C************************************************************************
C   SUBROUTINE TRMNAT HANDLES THE TERMINATION OF THE PROGRAM RUN WHEN
C       ONE OF THE PROGRAM'S ASSUMPTIONS HAVE BEEN VIOLATED
C
C************************************************************************
      SUBROUTINE TRMNAT

      WRITE(8,*) 'PROGRAM EXECUTION TERMINATED'
      STOP
      END

C***********************************************************************
C   SUBROUTINE PARDRW PERFORMS THE RANDOM LIFE DRIVER PARAMETER DRAWS IN 
C       THE INNER LOOP
C
C   DATE :      NOVEMBER 2012
C
C************************************************************************
      SUBROUTINE PARDRW (LAMGEOM, RAND)

      INTEGER  I, IOUT, J, K, L, MAXNGEOM, MAXNLDHIS

      PARAMETER (MAXNGEOM = 4, MAXNLDHIS = 1)

      DOUBLE PRECISION  RAND

      REAL     DUM, LAMGEOM(MAXNGEOM), 
     &         LAMGEOMA(MAXNGEOM), LAMGEOMB(MAXNGEOM)

      COMMON/DRIVRS/    LAMGEOMA,   LAMGEOMB
          
      COMMON IOUT

C   GEOMETRIC PARAMETERS DRAW
      DO 10 I = 1, MAXNGEOM
        CALL PRYRV (RAND, LAMGEOMA(I),LAMGEOMB(I), 
     &               0, 1, LAMGEOM(I), DUM)
   10 CONTINUE
         
      RETURN
      END
       
C************************************************************************
C   SUBROUTINE INPUT READS IN THE DATA AND ECHOES IT 
C
C   DATE :      NOVEMBER 2012
C
C************************************************************************
      SUBROUTINE INPUT (BLFPER, GEOMDATA, NGEOM, 
     &              NBLIFE, NHYPER, NLIFE, RAND, SGEOM, 
     &              DESCGEOM, WEARRATE, WEARMEAN, WEARSIGMA)
 
      IMPLICIT NONE

      INTEGER  MAXBLF, MAXNGEOM, MAXSGEOM

      PARAMETER (MAXBLF = 35, MAXNGEOM = 4, MAXSGEOM = 11)

      INTEGER  I, IOUT, J, K, L,  
     &         NBLIFE, NGEOM, NHYPER, NLIFE,  
     &         NTIME, SGEOM(MAXNGEOM), VARY

      DOUBLE PRECISION  RAND

      REAL     BLFPER(MAXBLF), GEOMDATA(MAXNGEOM, MAXSGEOM),
     &	       MAXGEOM(MAXNGEOM), MINGEOM(MAXNGEOM),
     &         LAMGEOMA(MAXNGEOM), LAMGEOMB(MAXNGEOM)
      
      REAL     WEARRATE, WEARMEAN, WEARSIGMA
      
      CHARACTER*40 DESCGEOM(MAXNGEOM)
          
      COMMON/DRIVRS/    LAMGEOMA,   LAMGEOMB

      COMMON  IOUT
      
      READ(1,*) RAND
      WRITE(8,*) '                         RANDOM NUMBER SEED =', RAND     
      READ(1,*) NLIFE
      WRITE(8,*) '                            INNER LOOP SIZE =', NLIFE
      READ(1,*) NHYPER
      WRITE(8,*) '                            OUTER LOOP SIZE =',NHYPER

      READ(1,*) NBLIFE
      IF (NBLIFE .GT. 0) READ(1,*) (BLFPER(J), J = 1, NBLIFE)

C   READ COMPONENT DATA 
      READ(2,*) NGEOM
      WRITE(8,*) '             NUMBER OF GEOMETRIC PARAMETERS =', NGEOM
      
      IF (NGEOM .GT. MAXNGEOM)THEN
        WRITE(8,*) 'ERROR: TOO MANY GEOMETRIC PARAMETERS'
        CALL TRMNAT
      ENDIF

C   INITIALIZE SGEOM, PGEOM
      DO 11 I = 1, MAXNGEOM
        SGEOM(I) = 1
   11 CONTINUE
            
      DO 10 I = 1, NGEOM
        READ(2,*)   DESCGEOM(I), MINGEOM(I), MAXGEOM(I), 
     &              LAMGEOMA(I), LAMGEOMB(I), SGEOM(I)
        IF ((SGEOM(I) .EQ. 1) .AND. 
     &           (MAXGEOM(I) .NE. MINGEOM(I))) THEN
            WRITE(8,*) 'ERROR: SGEOM =1 WHEN MAXGEOM = MINGEOM'
            CALL TRMNAT
        ENDIF
        IF (SGEOM(I) .GT. MAXSGEOM) THEN
            WRITE(8,*) 'ERROR: TOO MANY SEGMENTS FOR PARAMETER ', NGEOM
            CALL TRMNAT
        ELSE IF (SGEOM(I) .LE. 0) THEN
            WRITE(8,*) 'ERROR: NEGATIVE SEGMENT FOR PARAMETER ', NGEOM
            CALL TRMNAT
        ENDIF
   10 CONTINUE
   
C   CALCULATE INDIVIDUAL POINT FOR PARAMETERS             
      DO 60 I = 1, NGEOM
        DO 70 J = 1, SGEOM(I)
            IF ( MAXGEOM(I) .EQ. MINGEOM(I) ) THEN
                GEOMDATA(I, J) = MAXGEOM(I)
            ELSE
                GEOMDATA(I, J) = (J-1) * ( MAXGEOM(I) - MINGEOM(I) )
     &                  / (SGEOM(I)-1) + MINGEOM(I)
            ENDIF
   70   CONTINUE                    
   60 CONTINUE      
   
C   CALCULATE INDIVIDUAL POINT FOR PARAMETER 1 (NORMALIZAED SLIDING DISTANCE)
      DO 80 I = 1, SGEOM(1)
            GEOMDATA(1, I) = 10 ** GEOMDATA(1,I)
   80 CONTINUE  
      
      READ(2,*) WEARRATE, WEARMEAN, WEARSIGMA
      
 
C ** ECHO DATA TO WEAROUT
      WRITE(3,900)

      WRITE(3, 901) I, DESCGEOM(1), 10**MINGEOM(1), 10**MAXGEOM(1), 
     &                   LAMGEOMA(1), LAMGEOMB(1), SGEOM(1)

      DO 45 I = 2, NGEOM
        WRITE(3, 901) I, DESCGEOM(I), MINGEOM(I),MAXGEOM(I), 
     &                   LAMGEOMA(I), LAMGEOMB(I), SGEOM(I)
   45 CONTINUE
   
      DO 160 I = 1, NGEOM
        WRITE(3, *) 'PARAMETER #', I, DESCGEOM(I)
        DO 170 J = 1, SGEOM(I)
            WRITE(3, *) GEOMDATA(I, J)  
  170   CONTINUE                    
  160 CONTINUE
          

C============  FORMAT STATEMENTS TO ECHO INPUT DATA TO GDWOUT ==========

  900 FORMAT(28X,'ANGELES CREST ENGINEERING INC',//,
     &       21X,'WEAR DAMAGE',//
     &       36X,'INPUT DATA',
     &       ///,14X,'DRIVERS',28X,'PARAMETER DISTRIBUTIONS',//)

  901 FORMAT( 2X, 'PARAMETER #', I1, 5X, A40/,
     &        2X, 'LOWER BOUND = ', F12.5, 10X, 'UPPER BOUND = ', 
     &          F16.5,/,
     &        2X, 'UNCERTAINTY  ',21X,   'U(',F9.5,',',F9.5,')',/,
     &        2X, 'NUMBER OF PARAMETER POINTS = 'I2,/)
      
      RETURN
      END
            
